#!/usr/bin/env python
# -*- coding: utf-8 -*-

from sys import *
from random import *
from TOSSIM import *
from tinyos.tossim.TossimApp import *

n = NescApp()
t = Tossim(n.variables.variables())
t.addChannel("TEST-RecieveM", sys.stdout)
t.addChannel("TEST-SendM", sys.stdout)
t.addChannel("TEST-LedkyM", sys.stdout)
t.addChannel("TEST-ControlM", sys.stdout)
t.addChannel("TEST-WaitM", sys.stdout)
t.addChannel("Boot", sys.stdout)
t.addChannel("App", sys.stdout)
t.addChannel("ArrayC", sys.stdout)
t.addChannel("ArrayOpC", sys.stdout)
t.addChannel("ArrayDbg", sys.stdout)
t.addChannel("PlatformSvcC", sys.stdout)


r = t.radio()
r.add(1, 2, -54.0)
r.add(2, 1, -54.0)
r.add(1, 3, -54.0)
r.add(3, 1, -54.0)
r.add(2, 3, -51.0)
r.add(3, 2, -51.0)

r.add(1, 4, -54.0)
r.add(4, 1, -54.0)
r.add(2, 4, -51.0)
r.add(4, 2, -51.0)
r.add(3, 4, -54.0)
r.add(4, 3, -54.0)

r.add(1, 5, -51.0)
r.add(5, 1, -51.0)
r.add(2, 5, -54.0)
r.add(5, 2, -54.0)
r.add(3, 5, -51.0)
r.add(5, 3, -51.0)
r.add(4, 5, -54.0)
r.add(5, 4, -54.0)

noise = open("meyer-heavy.txt", "r")
lines = noise.readlines()
for line in lines:
  str = line.strip()
  if (str != ""):
    val = int(str)
    for i in range(1, 6):
      t.getNode(i).addNoiseTraceReading(val)

for i in range(1, 6):
  print "Creating noise model for ",i;
  t.getNode(i).createNoiseModel()

#normalne je to 1..4
for i in range (1, 6):
  t.getNode(i).bootAtTime(i * 2351217 + 23542399)

while t.runNextEvent():
  pass
